dnl Process this m4 file to produce 'C' language file.
dnl
dnl If you see this line, you can ignore the next one.
! Do not edit this file. It is produced from the corresponding .m4 source
dnl
!
!  Copyright (C) 2014, Northwestern University and Argonne National Laboratory
!  See COPYRIGHT notice in top-level directory.
!
! $Id$
!

dnl
dnl VARN1
dnl
define(`VARN1',dnl
`dnl
   ! $1 a scalar of type $5 (kind=$4)
   function nf90mpi_$1_varn_$4$2(ncid, varid, value, start)
     integer,                                        intent(in) :: ncid, varid
     $5 (kind=$4),                                   intent($3) :: value
     integer (kind=MPI_OFFSET_KIND), dimension(:,:), intent(in) :: start
     integer                                                    :: nf90mpi_$1_varn_$4$2

     nf90mpi_$1_varn_$4$2 = nfmpi_$1_var1_$6$2(ncid, varid, start(:,1), value)
   end function nf90mpi_$1_varn_$4$2
')dnl

VARN1(put,     , in,      OneByteInt,    integer, int1)
VARN1(put,     , INTENTV, TwoByteInt,    integer, int2)
VARN1(put,     , INTENTV, FourByteInt,   integer, int)
VARN1(put,     , INTENTV, FourByteReal,  real,    real)
VARN1(put,     , INTENTV, EightByteReal, real,    double)
VARN1(put,     , INTENTV, EightByteInt,  integer, int8)

VARN1(put, _all, in,      OneByteInt,    integer, int1)
VARN1(put, _all, INTENTV, TwoByteInt,    integer, int2)
VARN1(put, _all, INTENTV, FourByteInt,   integer, int)
VARN1(put, _all, INTENTV, FourByteReal,  real,    real)
VARN1(put, _all, INTENTV, EightByteReal, real,    double)
VARN1(put, _all, INTENTV, EightByteInt,  integer, int8)

VARN1(get,     , out,   OneByteInt,    integer, int1)
VARN1(get,     , out,   TwoByteInt,    integer, int2)
VARN1(get,     , out,   FourByteInt,   integer, int)
VARN1(get,     , out,   FourByteReal,  real,    real)
VARN1(get,     , out,   EightByteReal, real,    double)
VARN1(get,     , out,   EightByteInt,  integer, int8)

VARN1(get, _all, out,   OneByteInt,    integer, int1)
VARN1(get, _all, out,   TwoByteInt,    integer, int2)
VARN1(get, _all, out,   FourByteInt,   integer, int)
VARN1(get, _all, out,   FourByteReal,  real,    real)
VARN1(get, _all, out,   EightByteReal, real,    double)
VARN1(get, _all, out,   EightByteInt,  integer, int8)

dnl
dnl VARN(ncid, varid, values, num, start, count)
dnl
define(`VARN',dnl
`dnl
   function nf90mpi_$1_varn_$2D_$3$8(ncid, varid, values, num, start, count)
     integer,                                                  intent(in) :: ncid, varid, num
     $4 (kind=$3),                   dimension($6),            intent($7) :: values
     integer (kind=MPI_OFFSET_KIND), dimension(:,:),           intent(in) :: start
     integer (kind=MPI_OFFSET_KIND), dimension(:,:), optional, intent(in) :: count
     integer                                                              :: nf90mpi_$1_varn_$2D_$3$8
     integer (kind=MPI_OFFSET_KIND), allocatable                          :: localCount(:,:)
     integer                                                              :: ndims

     if (present(count)) then
         nf90mpi_$1_varn_$2D_$3$8 = nfmpi_$1_varn_$5$8(ncid, varid, num, start, &
                                                       count, values)
     else
         ! Set local arguments to default values
         nf90mpi_$1_varn_$2D_$3$8 = nfmpi_inq_varndims(ncid, varid, ndims)
         if (nf90mpi_$1_varn_$2D_$3$8 .NE. NF_NOERR) return
         allocate(localCount(ndims, num))
         localCount(:,:) = 1
         nf90mpi_$1_varn_$2D_$3$8 = nfmpi_$1_varn_$5$8(ncid, varid, num, start, &
                                                       localCount, values)
         deallocate(localCount)
     endif
   end function nf90mpi_$1_varn_$2D_$3$8
')dnl

!
! put APIs
!

VARN(put, 1, OneByteInt, integer, int1,  :,              in)
VARN(put, 2, OneByteInt, integer, int1, `:,:',           in)
VARN(put, 3, OneByteInt, integer, int1, `:,:,:',         in)
VARN(put, 4, OneByteInt, integer, int1, `:,:,:,:',       in)
VARN(put, 5, OneByteInt, integer, int1, `:,:,:,:,:',     in)
VARN(put, 6, OneByteInt, integer, int1, `:,:,:,:,:,:',   in)
VARN(put, 7, OneByteInt, integer, int1, `:,:,:,:,:,:,:', in)

VARN(put, 1, TwoByteInt, integer, int2,  :,              INTENTV)
VARN(put, 2, TwoByteInt, integer, int2, `:,:',           INTENTV)
VARN(put, 3, TwoByteInt, integer, int2, `:,:,:',         INTENTV)
VARN(put, 4, TwoByteInt, integer, int2, `:,:,:,:',       INTENTV)
VARN(put, 5, TwoByteInt, integer, int2, `:,:,:,:,:',     INTENTV)
VARN(put, 6, TwoByteInt, integer, int2, `:,:,:,:,:,:',   INTENTV)
VARN(put, 7, TwoByteInt, integer, int2, `:,:,:,:,:,:,:', INTENTV)

VARN(put, 1, FourByteInt, integer, int,  :,              INTENTV)
VARN(put, 2, FourByteInt, integer, int, `:,:',           INTENTV)
VARN(put, 3, FourByteInt, integer, int, `:,:,:',         INTENTV)
VARN(put, 4, FourByteInt, integer, int, `:,:,:,:',       INTENTV)
VARN(put, 5, FourByteInt, integer, int, `:,:,:,:,:',     INTENTV)
VARN(put, 6, FourByteInt, integer, int, `:,:,:,:,:,:',   INTENTV)
VARN(put, 7, FourByteInt, integer, int, `:,:,:,:,:,:,:', INTENTV)

VARN(put, 1, FourByteReal, real,   real,  :,              INTENTV)
VARN(put, 2, FourByteReal, real,   real, `:,:',           INTENTV)
VARN(put, 3, FourByteReal, real,   real, `:,:,:',         INTENTV)
VARN(put, 4, FourByteReal, real,   real, `:,:,:,:',       INTENTV)
VARN(put, 5, FourByteReal, real,   real, `:,:,:,:,:',     INTENTV)
VARN(put, 6, FourByteReal, real,   real, `:,:,:,:,:,:',   INTENTV)
VARN(put, 7, FourByteReal, real,   real, `:,:,:,:,:,:,:', INTENTV)

VARN(put, 1, EightByteReal, real, double,  :,              INTENTV)
VARN(put, 2, EightByteReal, real, double, `:,:',           INTENTV)
VARN(put, 3, EightByteReal, real, double, `:,:,:',         INTENTV)
VARN(put, 4, EightByteReal, real, double, `:,:,:,:',       INTENTV)
VARN(put, 5, EightByteReal, real, double, `:,:,:,:,:',     INTENTV)
VARN(put, 6, EightByteReal, real, double, `:,:,:,:,:,:',   INTENTV)
VARN(put, 7, EightByteReal, real, double, `:,:,:,:,:,:,:', INTENTV)

VARN(put, 1, EightByteInt, integer, int8,  :,              INTENTV)
VARN(put, 2, EightByteInt, integer, int8, `:,:',           INTENTV)
VARN(put, 3, EightByteInt, integer, int8, `:,:,:',         INTENTV)
VARN(put, 4, EightByteInt, integer, int8, `:,:,:,:',       INTENTV)
VARN(put, 5, EightByteInt, integer, int8, `:,:,:,:,:',     INTENTV)
VARN(put, 6, EightByteInt, integer, int8, `:,:,:,:,:,:',   INTENTV)
VARN(put, 7, EightByteInt, integer, int8, `:,:,:,:,:,:,:', INTENTV)

!
! get APIs
!

VARN(get, 1, OneByteInt, integer, int1,  :,              out)
VARN(get, 2, OneByteInt, integer, int1, `:,:',           out)
VARN(get, 3, OneByteInt, integer, int1, `:,:,:',         out)
VARN(get, 4, OneByteInt, integer, int1, `:,:,:,:',       out)
VARN(get, 5, OneByteInt, integer, int1, `:,:,:,:,:',     out)
VARN(get, 6, OneByteInt, integer, int1, `:,:,:,:,:,:',   out)
VARN(get, 7, OneByteInt, integer, int1, `:,:,:,:,:,:,:', out)

VARN(get, 1, TwoByteInt, integer, int2,  :,              out)
VARN(get, 2, TwoByteInt, integer, int2, `:,:',           out)
VARN(get, 3, TwoByteInt, integer, int2, `:,:,:',         out)
VARN(get, 4, TwoByteInt, integer, int2, `:,:,:,:',       out)
VARN(get, 5, TwoByteInt, integer, int2, `:,:,:,:,:',     out)
VARN(get, 6, TwoByteInt, integer, int2, `:,:,:,:,:,:',   out)
VARN(get, 7, TwoByteInt, integer, int2, `:,:,:,:,:,:,:', out)

VARN(get, 1, FourByteInt, integer, int,  :,              out)
VARN(get, 2, FourByteInt, integer, int, `:,:',           out)
VARN(get, 3, FourByteInt, integer, int, `:,:,:',         out)
VARN(get, 4, FourByteInt, integer, int, `:,:,:,:',       out)
VARN(get, 5, FourByteInt, integer, int, `:,:,:,:,:',     out)
VARN(get, 6, FourByteInt, integer, int, `:,:,:,:,:,:',   out)
VARN(get, 7, FourByteInt, integer, int, `:,:,:,:,:,:,:', out)

VARN(get, 1, FourByteReal, real,   real,  :,              out)
VARN(get, 2, FourByteReal, real,   real, `:,:',           out)
VARN(get, 3, FourByteReal, real,   real, `:,:,:',         out)
VARN(get, 4, FourByteReal, real,   real, `:,:,:,:',       out)
VARN(get, 5, FourByteReal, real,   real, `:,:,:,:,:',     out)
VARN(get, 6, FourByteReal, real,   real, `:,:,:,:,:,:',   out)
VARN(get, 7, FourByteReal, real,   real, `:,:,:,:,:,:,:', out)

VARN(get, 1, EightByteReal, real, double,  :,              out)
VARN(get, 2, EightByteReal, real, double, `:,:',           out)
VARN(get, 3, EightByteReal, real, double, `:,:,:',         out)
VARN(get, 4, EightByteReal, real, double, `:,:,:,:',       out)
VARN(get, 5, EightByteReal, real, double, `:,:,:,:,:',     out)
VARN(get, 6, EightByteReal, real, double, `:,:,:,:,:,:',   out)
VARN(get, 7, EightByteReal, real, double, `:,:,:,:,:,:,:', out)

VARN(get, 1, EightByteInt, integer, int8,  :,              out)
VARN(get, 2, EightByteInt, integer, int8, `:,:',           out)
VARN(get, 3, EightByteInt, integer, int8, `:,:,:',         out)
VARN(get, 4, EightByteInt, integer, int8, `:,:,:,:',       out)
VARN(get, 5, EightByteInt, integer, int8, `:,:,:,:,:',     out)
VARN(get, 6, EightByteInt, integer, int8, `:,:,:,:,:,:',   out)
VARN(get, 7, EightByteInt, integer, int8, `:,:,:,:,:,:,:', out)

!
! collective put APIs
!

VARN(put, 1, OneByteInt, integer, int1,  :,              in, _all)
VARN(put, 2, OneByteInt, integer, int1, `:,:',           in, _all)
VARN(put, 3, OneByteInt, integer, int1, `:,:,:',         in, _all)
VARN(put, 4, OneByteInt, integer, int1, `:,:,:,:',       in, _all)
VARN(put, 5, OneByteInt, integer, int1, `:,:,:,:,:',     in, _all)
VARN(put, 6, OneByteInt, integer, int1, `:,:,:,:,:,:',   in, _all)
VARN(put, 7, OneByteInt, integer, int1, `:,:,:,:,:,:,:', in, _all)

VARN(put, 1, TwoByteInt, integer, int2,  :,              INTENTV, _all)
VARN(put, 2, TwoByteInt, integer, int2, `:,:',           INTENTV, _all)
VARN(put, 3, TwoByteInt, integer, int2, `:,:,:',         INTENTV, _all)
VARN(put, 4, TwoByteInt, integer, int2, `:,:,:,:',       INTENTV, _all)
VARN(put, 5, TwoByteInt, integer, int2, `:,:,:,:,:',     INTENTV, _all)
VARN(put, 6, TwoByteInt, integer, int2, `:,:,:,:,:,:',   INTENTV, _all)
VARN(put, 7, TwoByteInt, integer, int2, `:,:,:,:,:,:,:', INTENTV, _all)

VARN(put, 1, FourByteInt, integer, int,  :,              INTENTV, _all)
VARN(put, 2, FourByteInt, integer, int, `:,:',           INTENTV, _all)
VARN(put, 3, FourByteInt, integer, int, `:,:,:',         INTENTV, _all)
VARN(put, 4, FourByteInt, integer, int, `:,:,:,:',       INTENTV, _all)
VARN(put, 5, FourByteInt, integer, int, `:,:,:,:,:',     INTENTV, _all)
VARN(put, 6, FourByteInt, integer, int, `:,:,:,:,:,:',   INTENTV, _all)
VARN(put, 7, FourByteInt, integer, int, `:,:,:,:,:,:,:', INTENTV, _all)

VARN(put, 1, FourByteReal, real,   real,  :,              INTENTV, _all)
VARN(put, 2, FourByteReal, real,   real, `:,:',           INTENTV, _all)
VARN(put, 3, FourByteReal, real,   real, `:,:,:',         INTENTV, _all)
VARN(put, 4, FourByteReal, real,   real, `:,:,:,:',       INTENTV, _all)
VARN(put, 5, FourByteReal, real,   real, `:,:,:,:,:',     INTENTV, _all)
VARN(put, 6, FourByteReal, real,   real, `:,:,:,:,:,:',   INTENTV, _all)
VARN(put, 7, FourByteReal, real,   real, `:,:,:,:,:,:,:', INTENTV, _all)

VARN(put, 1, EightByteReal, real, double,  :,              INTENTV, _all)
VARN(put, 2, EightByteReal, real, double, `:,:',           INTENTV, _all)
VARN(put, 3, EightByteReal, real, double, `:,:,:',         INTENTV, _all)
VARN(put, 4, EightByteReal, real, double, `:,:,:,:',       INTENTV, _all)
VARN(put, 5, EightByteReal, real, double, `:,:,:,:,:',     INTENTV, _all)
VARN(put, 6, EightByteReal, real, double, `:,:,:,:,:,:',   INTENTV, _all)
VARN(put, 7, EightByteReal, real, double, `:,:,:,:,:,:,:', INTENTV, _all)

VARN(put, 1, EightByteInt, integer, int8,  :,              INTENTV, _all)
VARN(put, 2, EightByteInt, integer, int8, `:,:',           INTENTV, _all)
VARN(put, 3, EightByteInt, integer, int8, `:,:,:',         INTENTV, _all)
VARN(put, 4, EightByteInt, integer, int8, `:,:,:,:',       INTENTV, _all)
VARN(put, 5, EightByteInt, integer, int8, `:,:,:,:,:',     INTENTV, _all)
VARN(put, 6, EightByteInt, integer, int8, `:,:,:,:,:,:',   INTENTV, _all)
VARN(put, 7, EightByteInt, integer, int8, `:,:,:,:,:,:,:', INTENTV, _all)

!
! collective get APIs
!

VARN(get, 1, OneByteInt, integer, int1,  :,              out, _all)
VARN(get, 2, OneByteInt, integer, int1, `:,:',           out, _all)
VARN(get, 3, OneByteInt, integer, int1, `:,:,:',         out, _all)
VARN(get, 4, OneByteInt, integer, int1, `:,:,:,:',       out, _all)
VARN(get, 5, OneByteInt, integer, int1, `:,:,:,:,:',     out, _all)
VARN(get, 6, OneByteInt, integer, int1, `:,:,:,:,:,:',   out, _all)
VARN(get, 7, OneByteInt, integer, int1, `:,:,:,:,:,:,:', out, _all)

VARN(get, 1, TwoByteInt, integer, int2,  :,              out, _all)
VARN(get, 2, TwoByteInt, integer, int2, `:,:',           out, _all)
VARN(get, 3, TwoByteInt, integer, int2, `:,:,:',         out, _all)
VARN(get, 4, TwoByteInt, integer, int2, `:,:,:,:',       out, _all)
VARN(get, 5, TwoByteInt, integer, int2, `:,:,:,:,:',     out, _all)
VARN(get, 6, TwoByteInt, integer, int2, `:,:,:,:,:,:',   out, _all)
VARN(get, 7, TwoByteInt, integer, int2, `:,:,:,:,:,:,:', out, _all)

VARN(get, 1, FourByteInt, integer, int,  :,              out, _all)
VARN(get, 2, FourByteInt, integer, int, `:,:',           out, _all)
VARN(get, 3, FourByteInt, integer, int, `:,:,:',         out, _all)
VARN(get, 4, FourByteInt, integer, int, `:,:,:,:',       out, _all)
VARN(get, 5, FourByteInt, integer, int, `:,:,:,:,:',     out, _all)
VARN(get, 6, FourByteInt, integer, int, `:,:,:,:,:,:',   out, _all)
VARN(get, 7, FourByteInt, integer, int, `:,:,:,:,:,:,:', out, _all)

VARN(get, 1, FourByteReal, real,   real,  :,              out, _all)
VARN(get, 2, FourByteReal, real,   real, `:,:',           out, _all)
VARN(get, 3, FourByteReal, real,   real, `:,:,:',         out, _all)
VARN(get, 4, FourByteReal, real,   real, `:,:,:,:',       out, _all)
VARN(get, 5, FourByteReal, real,   real, `:,:,:,:,:',     out, _all)
VARN(get, 6, FourByteReal, real,   real, `:,:,:,:,:,:',   out, _all)
VARN(get, 7, FourByteReal, real,   real, `:,:,:,:,:,:,:', out, _all)

VARN(get, 1, EightByteReal, real, double,  :,              out, _all)
VARN(get, 2, EightByteReal, real, double, `:,:',           out, _all)
VARN(get, 3, EightByteReal, real, double, `:,:,:',         out, _all)
VARN(get, 4, EightByteReal, real, double, `:,:,:,:',       out, _all)
VARN(get, 5, EightByteReal, real, double, `:,:,:,:,:',     out, _all)
VARN(get, 6, EightByteReal, real, double, `:,:,:,:,:,:',   out, _all)
VARN(get, 7, EightByteReal, real, double, `:,:,:,:,:,:,:', out, _all)

VARN(get, 1, EightByteInt, integer, int8,  :,              out, _all)
VARN(get, 2, EightByteInt, integer, int8, `:,:',           out, _all)
VARN(get, 3, EightByteInt, integer, int8, `:,:,:',         out, _all)
VARN(get, 4, EightByteInt, integer, int8, `:,:,:,:',       out, _all)
VARN(get, 5, EightByteInt, integer, int8, `:,:,:,:,:',     out, _all)
VARN(get, 6, EightByteInt, integer, int8, `:,:,:,:,:,:',   out, _all)
VARN(get, 7, EightByteInt, integer, int8, `:,:,:,:,:,:,:', out, _all)

!
! text variable
!

dnl
dnl TEXTVARN1(ncid, varid, values, num, start, count)
dnl
define(`TEXTVARN1',dnl
`dnl
   ! $1 a scalar of type character (len = *)
   function nf90mpi_$1_varn_text$3(ncid, varid, value, start)
     integer,                                        intent(in) :: ncid, varid
     character (len=*),                              intent($2) :: value
     integer (kind=MPI_OFFSET_KIND), dimension(:,:), intent(in) :: start
     integer                                                    :: nf90mpi_$1_varn_text$3

     nf90mpi_$1_varn_text$3 = nfmpi_$1_var1_text$3(ncid, varid, start(:,1), value)
   end function nf90mpi_$1_varn_text$3
')dnl

TEXTVARN1(put, in)
TEXTVARN1(get, out)
TEXTVARN1(put, in,  _all)
TEXTVARN1(get, out, _all)

dnl
dnl TEXTVARN(ncid, varid, values, num, start, count)
dnl
define(`TEXTVARN',dnl
`dnl
   function nf90mpi_$1_varn_$2D_text$6(ncid, varid, values, num, start, count)
     integer,                                                  intent(in) :: ncid, varid, num
     character (len=*),              dimension($3),            intent($5) :: values
     integer (kind=MPI_OFFSET_KIND), dimension(:,:),           intent(in) :: start
     integer (kind=MPI_OFFSET_KIND), dimension(:,:), optional, intent(in) :: count
     integer                                                              :: nf90mpi_$1_varn_$2D_text$6
     integer (kind=MPI_OFFSET_KIND), allocatable                          :: localCount(:,:)
     integer                                                              :: ndims

     if (present(count)) then
         nf90mpi_$1_varn_$2D_text$6 = nfmpi_$1_varn_text$6(ncid, varid, num, start, &
                                                           count, values($4))
     else
         ! Set local arguments to default values
         nf90mpi_$1_varn_$2D_text$6 = nfmpi_inq_varndims(ncid, varid, ndims)
         if (nf90mpi_$1_varn_$2D_text$6 .NE. NF_NOERR) return
         allocate(localCount(ndims, num))
         localCount(:,:) = 1
         nf90mpi_$1_varn_$2D_text$6 = nfmpi_$1_varn_text$6(ncid, varid, num, start, &
                                                           localCount, values($4))
         deallocate(localCount)
     endif
   end function nf90mpi_$1_varn_$2D_text$6
')dnl

TEXTVARN(put, 1,  :,               1,              in)
TEXTVARN(put, 2, `:,:',           `1,1',           in)
TEXTVARN(put, 3, `:,:,:',         `1,1,1',         in)
TEXTVARN(put, 4, `:,:,:,:',       `1,1,1,1',       in)
TEXTVARN(put, 5, `:,:,:,:,:',     `1,1,1,1,1',     in)
TEXTVARN(put, 6, `:,:,:,:,:,:',   `1,1,1,1,1,1',   in)
TEXTVARN(put, 7, `:,:,:,:,:,:,:', `1,1,1,1,1,1,1', in)

TEXTVARN(get, 1,  :,               1,              out)
TEXTVARN(get, 2, `:,:',           `1,1',           out)
TEXTVARN(get, 3, `:,:,:',         `1,1,1',         out)
TEXTVARN(get, 4, `:,:,:,:',       `1,1,1,1',       out)
TEXTVARN(get, 5, `:,:,:,:,:',     `1,1,1,1,1',     out)
TEXTVARN(get, 6, `:,:,:,:,:,:',   `1,1,1,1,1,1',   out)
TEXTVARN(get, 7, `:,:,:,:,:,:,:', `1,1,1,1,1,1,1', out)

!
! Collective APIs
!

TEXTVARN(put, 1,  :,               1,              in, _all)
TEXTVARN(put, 2, `:,:',           `1,1',           in, _all)
TEXTVARN(put, 3, `:,:,:',         `1,1,1',         in, _all)
TEXTVARN(put, 4, `:,:,:,:',       `1,1,1,1',       in, _all)
TEXTVARN(put, 5, `:,:,:,:,:',     `1,1,1,1,1',     in, _all)
TEXTVARN(put, 6, `:,:,:,:,:,:',   `1,1,1,1,1,1',   in, _all)
TEXTVARN(put, 7, `:,:,:,:,:,:,:', `1,1,1,1,1,1,1', in, _all)

TEXTVARN(get, 1,  :,               1,              out, _all)
TEXTVARN(get, 2, `:,:',           `1,1',           out, _all)
TEXTVARN(get, 3, `:,:,:',         `1,1,1',         out, _all)
TEXTVARN(get, 4, `:,:,:,:',       `1,1,1,1',       out, _all)
TEXTVARN(get, 5, `:,:,:,:,:',     `1,1,1,1,1',     out, _all)
TEXTVARN(get, 6, `:,:,:,:,:,:',   `1,1,1,1,1,1',   out, _all)
TEXTVARN(get, 7, `:,:,:,:,:,:,:', `1,1,1,1,1,1,1', out, _all)

!
! Nonblocking APIs
!

dnl
dnl IVARN1
dnl
define(`IVARN1',dnl
`dnl
   ! $1 a scalar of type $4 (kind=$3)
   function nf90mpi_$1_varn_$3(ncid, varid, value, req, start)
     integer,                                        intent(in) :: ncid, varid
     $4 (kind=$3),                                   intent($2) :: value
     integer,                                        intent(out):: req
     integer (kind=MPI_OFFSET_KIND), dimension(:,:), intent(in) :: start
     integer                                                    :: nf90mpi_$1_varn_$3

     nf90mpi_$1_varn_$3 = nfmpi_$1_var1_$5(ncid, varid, start(:,1), value, req)
   end function nf90mpi_$1_varn_$3
')dnl

IVARN1(iput, in,    OneByteInt,    integer, int1)
IVARN1(iput, INTENTV, TwoByteInt,    integer, int2)
IVARN1(iput, INTENTV, FourByteInt,   integer, int)
IVARN1(iput, INTENTV, FourByteReal,  real,    real)
IVARN1(iput, INTENTV, EightByteReal, real,    double)
IVARN1(iput, INTENTV, EightByteInt,  integer, int8)

IVARN1(iget, out,   OneByteInt,    integer, int1)
IVARN1(iget, out,   TwoByteInt,    integer, int2)
IVARN1(iget, out,   FourByteInt,   integer, int)
IVARN1(iget, out,   FourByteReal,  real,    real)
IVARN1(iget, out,   EightByteReal, real,    double)
IVARN1(iget, out,   EightByteInt,  integer, int8)

IVARN1(bput, in,    OneByteInt,    integer, int1)
IVARN1(bput, INTENTV, TwoByteInt,    integer, int2)
IVARN1(bput, INTENTV, FourByteInt,   integer, int)
IVARN1(bput, INTENTV, FourByteReal,  real,    real)
IVARN1(bput, INTENTV, EightByteReal, real,    double)
IVARN1(bput, INTENTV, EightByteInt,  integer, int8)

dnl
dnl IVARN(ncid, varid, values, num, start, count)
dnl
define(`IVARN',dnl
`dnl
   function nf90mpi_$1_varn_$2D_$3(ncid, varid, values, req, num, start, count)
     integer,                                                  intent(in) :: ncid, varid, num
     $4 (kind=$3),                   dimension($6),            intent($7) :: values
     integer,                                                  intent(out):: req
     integer (kind=MPI_OFFSET_KIND), dimension(:,:),           intent(in) :: start
     integer (kind=MPI_OFFSET_KIND), dimension(:,:), optional, intent(in) :: count
     integer                                                              :: nf90mpi_$1_varn_$2D_$3
     integer (kind=MPI_OFFSET_KIND), allocatable                          :: localCount(:,:)
     integer                                                              :: ndims

     if (present(count)) then
         nf90mpi_$1_varn_$2D_$3 = nfmpi_$1_varn_$5(ncid, varid, num, start, &
                                                   count, values, req)
     else
         ! Set local arguments to default values
         nf90mpi_$1_varn_$2D_$3 = nfmpi_inq_varndims(ncid, varid, ndims)
         if (nf90mpi_$1_varn_$2D_$3 .NE. NF_NOERR) return
         allocate(localCount(ndims, num))
         localCount(:,:) = 1
         nf90mpi_$1_varn_$2D_$3 = nfmpi_$1_varn_$5(ncid, varid, num, start, &
                                                   localCount, values, req)
         deallocate(localCount)
     endif
   end function nf90mpi_$1_varn_$2D_$3
')dnl

!
! put APIs
!

IVARN(iput, 1, OneByteInt, integer, int1,  :,              in)
IVARN(iput, 2, OneByteInt, integer, int1, `:,:',           in)
IVARN(iput, 3, OneByteInt, integer, int1, `:,:,:',         in)
IVARN(iput, 4, OneByteInt, integer, int1, `:,:,:,:',       in)
IVARN(iput, 5, OneByteInt, integer, int1, `:,:,:,:,:',     in)
IVARN(iput, 6, OneByteInt, integer, int1, `:,:,:,:,:,:',   in)
IVARN(iput, 7, OneByteInt, integer, int1, `:,:,:,:,:,:,:', in)

IVARN(iput, 1, TwoByteInt, integer, int2,  :,              INTENTV)
IVARN(iput, 2, TwoByteInt, integer, int2, `:,:',           INTENTV)
IVARN(iput, 3, TwoByteInt, integer, int2, `:,:,:',         INTENTV)
IVARN(iput, 4, TwoByteInt, integer, int2, `:,:,:,:',       INTENTV)
IVARN(iput, 5, TwoByteInt, integer, int2, `:,:,:,:,:',     INTENTV)
IVARN(iput, 6, TwoByteInt, integer, int2, `:,:,:,:,:,:',   INTENTV)
IVARN(iput, 7, TwoByteInt, integer, int2, `:,:,:,:,:,:,:', INTENTV)

IVARN(iput, 1, FourByteInt, integer, int,  :,              INTENTV)
IVARN(iput, 2, FourByteInt, integer, int, `:,:',           INTENTV)
IVARN(iput, 3, FourByteInt, integer, int, `:,:,:',         INTENTV)
IVARN(iput, 4, FourByteInt, integer, int, `:,:,:,:',       INTENTV)
IVARN(iput, 5, FourByteInt, integer, int, `:,:,:,:,:',     INTENTV)
IVARN(iput, 6, FourByteInt, integer, int, `:,:,:,:,:,:',   INTENTV)
IVARN(iput, 7, FourByteInt, integer, int, `:,:,:,:,:,:,:', INTENTV)

IVARN(iput, 1, FourByteReal, real,   real,  :,              INTENTV)
IVARN(iput, 2, FourByteReal, real,   real, `:,:',           INTENTV)
IVARN(iput, 3, FourByteReal, real,   real, `:,:,:',         INTENTV)
IVARN(iput, 4, FourByteReal, real,   real, `:,:,:,:',       INTENTV)
IVARN(iput, 5, FourByteReal, real,   real, `:,:,:,:,:',     INTENTV)
IVARN(iput, 6, FourByteReal, real,   real, `:,:,:,:,:,:',   INTENTV)
IVARN(iput, 7, FourByteReal, real,   real, `:,:,:,:,:,:,:', INTENTV)

IVARN(iput, 1, EightByteReal, real, double,  :,              INTENTV)
IVARN(iput, 2, EightByteReal, real, double, `:,:',           INTENTV)
IVARN(iput, 3, EightByteReal, real, double, `:,:,:',         INTENTV)
IVARN(iput, 4, EightByteReal, real, double, `:,:,:,:',       INTENTV)
IVARN(iput, 5, EightByteReal, real, double, `:,:,:,:,:',     INTENTV)
IVARN(iput, 6, EightByteReal, real, double, `:,:,:,:,:,:',   INTENTV)
IVARN(iput, 7, EightByteReal, real, double, `:,:,:,:,:,:,:', INTENTV)

IVARN(iput, 1, EightByteInt, integer, int8,  :,              INTENTV)
IVARN(iput, 2, EightByteInt, integer, int8, `:,:',           INTENTV)
IVARN(iput, 3, EightByteInt, integer, int8, `:,:,:',         INTENTV)
IVARN(iput, 4, EightByteInt, integer, int8, `:,:,:,:',       INTENTV)
IVARN(iput, 5, EightByteInt, integer, int8, `:,:,:,:,:',     INTENTV)
IVARN(iput, 6, EightByteInt, integer, int8, `:,:,:,:,:,:',   INTENTV)
IVARN(iput, 7, EightByteInt, integer, int8, `:,:,:,:,:,:,:', INTENTV)

!
! get APIs
!

IVARN(iget, 1, OneByteInt, integer, int1,  :,              out)
IVARN(iget, 2, OneByteInt, integer, int1, `:,:',           out)
IVARN(iget, 3, OneByteInt, integer, int1, `:,:,:',         out)
IVARN(iget, 4, OneByteInt, integer, int1, `:,:,:,:',       out)
IVARN(iget, 5, OneByteInt, integer, int1, `:,:,:,:,:',     out)
IVARN(iget, 6, OneByteInt, integer, int1, `:,:,:,:,:,:',   out)
IVARN(iget, 7, OneByteInt, integer, int1, `:,:,:,:,:,:,:', out)

IVARN(iget, 1, TwoByteInt, integer, int2,  :,              out)
IVARN(iget, 2, TwoByteInt, integer, int2, `:,:',           out)
IVARN(iget, 3, TwoByteInt, integer, int2, `:,:,:',         out)
IVARN(iget, 4, TwoByteInt, integer, int2, `:,:,:,:',       out)
IVARN(iget, 5, TwoByteInt, integer, int2, `:,:,:,:,:',     out)
IVARN(iget, 6, TwoByteInt, integer, int2, `:,:,:,:,:,:',   out)
IVARN(iget, 7, TwoByteInt, integer, int2, `:,:,:,:,:,:,:', out)

IVARN(iget, 1, FourByteInt, integer, int,  :,              out)
IVARN(iget, 2, FourByteInt, integer, int, `:,:',           out)
IVARN(iget, 3, FourByteInt, integer, int, `:,:,:',         out)
IVARN(iget, 4, FourByteInt, integer, int, `:,:,:,:',       out)
IVARN(iget, 5, FourByteInt, integer, int, `:,:,:,:,:',     out)
IVARN(iget, 6, FourByteInt, integer, int, `:,:,:,:,:,:',   out)
IVARN(iget, 7, FourByteInt, integer, int, `:,:,:,:,:,:,:', out)

IVARN(iget, 1, FourByteReal, real,   real,  :,              out)
IVARN(iget, 2, FourByteReal, real,   real, `:,:',           out)
IVARN(iget, 3, FourByteReal, real,   real, `:,:,:',         out)
IVARN(iget, 4, FourByteReal, real,   real, `:,:,:,:',       out)
IVARN(iget, 5, FourByteReal, real,   real, `:,:,:,:,:',     out)
IVARN(iget, 6, FourByteReal, real,   real, `:,:,:,:,:,:',   out)
IVARN(iget, 7, FourByteReal, real,   real, `:,:,:,:,:,:,:', out)

IVARN(iget, 1, EightByteReal, real, double,  :,              out)
IVARN(iget, 2, EightByteReal, real, double, `:,:',           out)
IVARN(iget, 3, EightByteReal, real, double, `:,:,:',         out)
IVARN(iget, 4, EightByteReal, real, double, `:,:,:,:',       out)
IVARN(iget, 5, EightByteReal, real, double, `:,:,:,:,:',     out)
IVARN(iget, 6, EightByteReal, real, double, `:,:,:,:,:,:',   out)
IVARN(iget, 7, EightByteReal, real, double, `:,:,:,:,:,:,:', out)

IVARN(iget, 1, EightByteInt, integer, int8,  :,              out)
IVARN(iget, 2, EightByteInt, integer, int8, `:,:',           out)
IVARN(iget, 3, EightByteInt, integer, int8, `:,:,:',         out)
IVARN(iget, 4, EightByteInt, integer, int8, `:,:,:,:',       out)
IVARN(iget, 5, EightByteInt, integer, int8, `:,:,:,:,:',     out)
IVARN(iget, 6, EightByteInt, integer, int8, `:,:,:,:,:,:',   out)
IVARN(iget, 7, EightByteInt, integer, int8, `:,:,:,:,:,:,:', out)

!
! bput APIs
!

IVARN(bput, 1, OneByteInt, integer, int1,  :,              in)
IVARN(bput, 2, OneByteInt, integer, int1, `:,:',           in)
IVARN(bput, 3, OneByteInt, integer, int1, `:,:,:',         in)
IVARN(bput, 4, OneByteInt, integer, int1, `:,:,:,:',       in)
IVARN(bput, 5, OneByteInt, integer, int1, `:,:,:,:,:',     in)
IVARN(bput, 6, OneByteInt, integer, int1, `:,:,:,:,:,:',   in)
IVARN(bput, 7, OneByteInt, integer, int1, `:,:,:,:,:,:,:', in)

IVARN(bput, 1, TwoByteInt, integer, int2,  :,              INTENTV)
IVARN(bput, 2, TwoByteInt, integer, int2, `:,:',           INTENTV)
IVARN(bput, 3, TwoByteInt, integer, int2, `:,:,:',         INTENTV)
IVARN(bput, 4, TwoByteInt, integer, int2, `:,:,:,:',       INTENTV)
IVARN(bput, 5, TwoByteInt, integer, int2, `:,:,:,:,:',     INTENTV)
IVARN(bput, 6, TwoByteInt, integer, int2, `:,:,:,:,:,:',   INTENTV)
IVARN(bput, 7, TwoByteInt, integer, int2, `:,:,:,:,:,:,:', INTENTV)

IVARN(bput, 1, FourByteInt, integer, int,  :,              INTENTV)
IVARN(bput, 2, FourByteInt, integer, int, `:,:',           INTENTV)
IVARN(bput, 3, FourByteInt, integer, int, `:,:,:',         INTENTV)
IVARN(bput, 4, FourByteInt, integer, int, `:,:,:,:',       INTENTV)
IVARN(bput, 5, FourByteInt, integer, int, `:,:,:,:,:',     INTENTV)
IVARN(bput, 6, FourByteInt, integer, int, `:,:,:,:,:,:',   INTENTV)
IVARN(bput, 7, FourByteInt, integer, int, `:,:,:,:,:,:,:', INTENTV)

IVARN(bput, 1, FourByteReal, real,   real,  :,              INTENTV)
IVARN(bput, 2, FourByteReal, real,   real, `:,:',           INTENTV)
IVARN(bput, 3, FourByteReal, real,   real, `:,:,:',         INTENTV)
IVARN(bput, 4, FourByteReal, real,   real, `:,:,:,:',       INTENTV)
IVARN(bput, 5, FourByteReal, real,   real, `:,:,:,:,:',     INTENTV)
IVARN(bput, 6, FourByteReal, real,   real, `:,:,:,:,:,:',   INTENTV)
IVARN(bput, 7, FourByteReal, real,   real, `:,:,:,:,:,:,:', INTENTV)

IVARN(bput, 1, EightByteReal, real, double,  :,              INTENTV)
IVARN(bput, 2, EightByteReal, real, double, `:,:',           INTENTV)
IVARN(bput, 3, EightByteReal, real, double, `:,:,:',         INTENTV)
IVARN(bput, 4, EightByteReal, real, double, `:,:,:,:',       INTENTV)
IVARN(bput, 5, EightByteReal, real, double, `:,:,:,:,:',     INTENTV)
IVARN(bput, 6, EightByteReal, real, double, `:,:,:,:,:,:',   INTENTV)
IVARN(bput, 7, EightByteReal, real, double, `:,:,:,:,:,:,:', INTENTV)

IVARN(bput, 1, EightByteInt, integer, int8,  :,              INTENTV)
IVARN(bput, 2, EightByteInt, integer, int8, `:,:',           INTENTV)
IVARN(bput, 3, EightByteInt, integer, int8, `:,:,:',         INTENTV)
IVARN(bput, 4, EightByteInt, integer, int8, `:,:,:,:',       INTENTV)
IVARN(bput, 5, EightByteInt, integer, int8, `:,:,:,:,:',     INTENTV)
IVARN(bput, 6, EightByteInt, integer, int8, `:,:,:,:,:,:',   INTENTV)
IVARN(bput, 7, EightByteInt, integer, int8, `:,:,:,:,:,:,:', INTENTV)

!
! text variable
!

dnl
dnl ITEXTVARN1
dnl
define(`ITEXTVARN1',dnl
`dnl
   ! $1 a scalar of type character (len = *)
   function nf90mpi_$1_varn_text(ncid, varid, value, req, start)
     integer,                                        intent(in) :: ncid, varid
     character (len = *),                            intent($2) :: value
     integer,                                        intent(out):: req
     integer (kind=MPI_OFFSET_KIND), dimension(:,:), intent(in) :: start
     integer                                                    :: nf90mpi_$1_varn_text

     nf90mpi_$1_varn_text = nfmpi_$1_var1_text(ncid, varid, start(:,1), value, req)
   end function nf90mpi_$1_varn_text
')dnl

ITEXTVARN1(iput, in)
ITEXTVARN1(iget, out)
ITEXTVARN1(bput, in)

dnl
dnl ITEXTVARN(ncid, varid, values, num, start, count)
dnl
define(`ITEXTVARN',dnl
`dnl
   function nf90mpi_$1_varn_$2D_text(ncid, varid, values, req, num, start, count)
     integer,                                                  intent(in) :: ncid, varid, num
     character (len=*),              dimension($3),            intent($5) :: values
     integer,                                                  intent(out):: req
     integer (kind=MPI_OFFSET_KIND), dimension(:,:),           intent(in) :: start
     integer (kind=MPI_OFFSET_KIND), dimension(:,:), optional, intent(in) :: count
     integer                                                              :: nf90mpi_$1_varn_$2D_text
     integer (kind=MPI_OFFSET_KIND), allocatable                          :: localCount(:,:)
     integer                                                              :: ndims

     if (present(count)) then
         nf90mpi_$1_varn_$2D_text = nfmpi_$1_varn_text(ncid, varid, num, start, &
                                                       count, values($4), req)
     else
         ! Set local arguments to default values
         nf90mpi_$1_varn_$2D_text = nfmpi_inq_varndims(ncid, varid, ndims)
         if (nf90mpi_$1_varn_$2D_text .NE. NF_NOERR) return
         allocate(localCount(ndims, num))
         localCount(:,:) = 1
         nf90mpi_$1_varn_$2D_text = nfmpi_$1_varn_text(ncid, varid, num, start, &
                                                       localCount, values($4), req)
         deallocate(localCount)
     endif
   end function nf90mpi_$1_varn_$2D_text
')dnl

ITEXTVARN(iput, 1,  :,               1,              in)
ITEXTVARN(iput, 2, `:,:',           `1,1',           in)
ITEXTVARN(iput, 3, `:,:,:',         `1,1,1',         in)
ITEXTVARN(iput, 4, `:,:,:,:',       `1,1,1,1',       in)
ITEXTVARN(iput, 5, `:,:,:,:,:',     `1,1,1,1,1',     in)
ITEXTVARN(iput, 6, `:,:,:,:,:,:',   `1,1,1,1,1,1',   in)
ITEXTVARN(iput, 7, `:,:,:,:,:,:,:', `1,1,1,1,1,1,1', in)

ITEXTVARN(iget, 1,  :,               1,              out)
ITEXTVARN(iget, 2, `:,:',           `1,1',           out)
ITEXTVARN(iget, 3, `:,:,:',         `1,1,1',         out)
ITEXTVARN(iget, 4, `:,:,:,:',       `1,1,1,1',       out)
ITEXTVARN(iget, 5, `:,:,:,:,:',     `1,1,1,1,1',     out)
ITEXTVARN(iget, 6, `:,:,:,:,:,:',   `1,1,1,1,1,1',   out)
ITEXTVARN(iget, 7, `:,:,:,:,:,:,:', `1,1,1,1,1,1,1', out)

ITEXTVARN(bput, 1,  :,               1,              in)
ITEXTVARN(bput, 2, `:,:',           `1,1',           in)
ITEXTVARN(bput, 3, `:,:,:',         `1,1,1',         in)
ITEXTVARN(bput, 4, `:,:,:,:',       `1,1,1,1',       in)
ITEXTVARN(bput, 5, `:,:,:,:,:',     `1,1,1,1,1',     in)
ITEXTVARN(bput, 6, `:,:,:,:,:,:',   `1,1,1,1,1,1',   in)
ITEXTVARN(bput, 7, `:,:,:,:,:,:,:', `1,1,1,1,1,1,1', in)

